@ECHO OFF
REM ---------------------------------------------------------------
REM PELLESC Batch for BCX v1.15
REM Makes EXEs (CON and GUI and DLL and CCON and CGUI).
REM Usage  : PELLESC.BAT [CON or GUI or DLL or CCON or CGUI] [UPX or NOUPX] ExtraFile1 ExtraFile2...
REM ---------------------------------------------------------------

ECHO PellesC Batch for BCX v1.15

IF (%3) == () GOTO MKERROR
IF (%2) == () GOTO MKERROR
IF (%1) == () GOTO MKERROR
IF %1 == ccon  GOTO CONLY
IF %1 == CCON  GOTO CONLY
IF %1 == cgui  GOTO CONLY
IF %1 == CGUI  GOTO CONLY
IF EXIST %3.bas GOTO BCBAS
IF EXIST %3.inc GOTO BCINC
IF EXIST %3.frm COPY %3.frm %3.bas
IF NOT EXIST %3.BAS GOTO MKERROR

:BCBAS
ECHO.
ECHO *********************************
ECHO **                             **
ECHO *    Translating Source File    *
ECHO **                             **
ECHO *********************************
ECHO.
REM IF EXIST %3.c   DEL %3.c
IF EXIST %3.obj DEL %3.obj
call D:\Ide\BCX\bin\povars32.bat
ECHO.
bc %3.bas -p -m
ECHO.
IF EXIST res\%3.rc GOTO RESCOMPILE
IF NOT EXIST res\%3.rc GOTO NORES
GOTO RESCOMPILE

:BCINC
ECHO.
ECHO *********************************
ECHO **                             **
ECHO *    Translating Source File    *
ECHO **                             **
ECHO *********************************
ECHO.
REM IF EXIST %3.c   DEL %3.c
IF EXIST %3.obj DEL %3.obj
CALL povars32.bat
ECHO.
bc %3.inc -p -m
ECHO.
IF EXIST res\%3.rc GOTO RESCOMPILE
IF NOT EXIST res\%3.rc GOTO NORES
GOTO RESCOMPILE

:CONLY
CALL povars32.bat
ECHO.
IF EXIST res\%3.rc GOTO RESCOMPILE
IF NOT EXIST res\%3.rc GOTO NORES
GOTO RESCOMPILE

:RESCOMPILE
ECHO ***************************
ECHO **                       **
ECHO * Compiling Resource File *
ECHO **                       **
ECHO ***************************
ECHO.
porc res\%3 -Fo res\%3.res -v
GOTO SWITCH

:NORES
ECHO ********************************************************************
ECHO.
ECHO                        NO .rc FILE FOUND!
ECHO    To use a .rc file put one in a 'res' subdirectory in the same
ECHO    location as your main program and name it %3.rc
ECHO    ex. res\%3.rc
ECHO.
ECHO ********************************************************************
ECHO.
GOTO SWITCH

:SWITCH
IF %1 == GUI  GOTO MKGUI
IF %1 == CON  GOTO MKCON
IF %1 == gui  GOTO MKGUI
IF %1 == con  GOTO MKCON
IF %1 == DLL  GOTO MKDLL
IF %1 == dll  GOTO MKDLL
IF %1 == ccon  GOTO MKCON
IF %1 == CCON  GOTO MKCON
IF %1 == cgui  GOTO MKGUI
IF %1 == CGUI  GOTO MKGUI
GOTO MKERROR

:MKCON
IF NOT EXIST %3.C GOTO BCXERROR
ECHO.
ECHO *********************************
ECHO **                             **
ECHO *   Building CONSOLE program    *
ECHO **                             **
ECHO *********************************
ECHO.
pocc -W1 -Ot -Gd -Go -Ze -Zx -Tx86-coff %3.c
IF NOT EXIST res\%3.res GOTO CONNORES
IF NOT EXIST %3.OBJ GOTO PELLESCERROR
polink -release -machine:ix86 -subsystem:console %3.obj res\%3.res kernel32.lib advapi32.lib delayimp.lib user32.lib gdi32.lib comctl32.lib comdlg32.lib %4 %5 %6
IF NOT EXIST %3.EXE GOTO LNKERROR
IF %2 == NOUPX GOTO PURGE
IF %2 == noupx GOTO PURGE
ECHO ***************************
ECHO **                       **
ECHO * COMPRESSING OUTPUT FILE *
ECHO **                       **
ECHO ***************************
ECHO.
UPX.EXE --best -qq %3.exe 
GOTO PURGE

:MKGUI
IF NOT EXIST %3.C GOTO BCXERROR
ECHO.
ECHO ***************************
ECHO **                       **
ECHO *  Building GUI program   *
ECHO **                       **
ECHO ***************************
ECHO.
REM pocc -W1 -Ot -Gd -Go -Ze -Zx -Tx86-coff -Ic:\pellesc\include;c:\pellesc\include\sys;c:\pellesc\include\win %3.c
pocc -W1 -Ot -Gd -Go -Ze -Zx -Tx86-coff %3.c
IF NOT EXIST res\%3.res GOTO GUINORES
IF NOT EXIST %3.OBJ GOTO PELLESCERROR
REM polink -release -machine:ix86 -subsystem:windows %3.obj res\%3.res -LIBPATH:"C:\Program Files\PellesC\Lib";"C:\Program Files\PellesC\Lib\Win" shell32.lib uuid.lib ole32.lib kernel32.lib advapi32.lib delayimp.lib user32.lib gdi32.lib comctl32.lib comdlg32.lib %4 %5 %6
polink -release -machine:ix86 -subsystem:windows %3.obj res\%3.res kernel32.lib advapi32.lib delayimp.lib user32.lib gdi32.lib comctl32.lib comdlg32.lib %4 %5 %6
IF NOT EXIST %3.EXE GOTO LNKERROR
IF %2 == NOUPX GOTO PURGE
IF %2 == noupx GOTO PURGE
ECHO ***************************
ECHO **                       **
ECHO * COMPRESSING OUTPUT FILE *
ECHO **                       **
ECHO ***************************
ECHO.
UPX.EXE --best -qq %3.exe 
GOTO PURGE

:MKDLL
IF NOT EXIST %3.C GOTO BCXERROR
ECHO.
ECHO *********************************
ECHO **                             **
ECHO *   Building DLL program        *
ECHO **                             **
ECHO *********************************
ECHO.
pocc -W1 -Ot -Gn -Go -Ze -Zx -Tx86-coff %3.c
IF NOT EXIST res\%3.res GOTO DLLNORES
IF NOT EXIST %3.OBJ GOTO PELLESCERROR
polink -dll -release -machine:ix86 -subsystem:windows %3.obj res\%3.res kernel32.lib advapi32.lib delayimp.lib user32.lib gdi32.lib comctl32.lib comdlg32.lib %4 %5 %6
IF NOT EXIST %3.dll GOTO LNKERROR
IF %2 == NOUPX GOTO PURGE
IF %2 == noupx GOTO PURGE
ECHO ***************************
ECHO **                       **
ECHO * COMPRESSING OUTPUT FILE *
ECHO **                       **
ECHO ***************************
ECHO.
UPX.EXE --best -qq %3.dll 
GOTO PURGE


:GUINORES
IF NOT EXIST %3.OBJ GOTO PELLESCERROR
polink -release -machine:ix86 -subsystem:windows %3.obj kernel32.lib advapi32.lib delayimp.lib user32.lib gdi32.lib comctl32.lib comdlg32.lib %4 %5 %6
IF NOT EXIST %3.EXE GOTO LNKERROR
IF %2 == NOUPX GOTO PURGE
IF %2 == noupx GOTO PURGE
ECHO ***************************
ECHO **                       **
ECHO * COMPRESSING OUTPUT FILE *
ECHO **                       **
ECHO ***************************
ECHO.
UPX.EXE --best -qq %3.exe 
GOTO PURGE

:CONNORES
IF NOT EXIST %3.OBJ GOTO PELLESCERROR
polink -release -machine:ix86 -subsystem:console %3.obj kernel32.lib advapi32.lib delayimp.lib user32.lib gdi32.lib comctl32.lib comdlg32.lib %4 %5 %6
IF NOT EXIST %3.EXE GOTO LNKERROR
IF %2 == NOUPX GOTO PURGE
IF %2 == noupx GOTO PURGE
ECHO ***************************
ECHO **                       **
ECHO * COMPRESSING OUTPUT FILE *
ECHO **                       **
ECHO ***************************
ECHO.
UPX.EXE --best -qq %3.exe 
GOTO PURGE

:DLLNORES
IF NOT EXIST %3.OBJ GOTO PELLESCERROR
polink -dll -release -machine:ix86 -subsystem:windows %3.obj kernel32.lib advapi32.lib delayimp.lib user32.lib gdi32.lib comctl32.lib comdlg32.lib %4 %5 %6
IF NOT EXIST %3.dll GOTO LNKERROR
IF %2 == NOUPX GOTO PURGE
IF %2 == noupx GOTO PURGE
ECHO ***************************
ECHO **                       **
ECHO * COMPRESSING OUTPUT FILE *
ECHO **                       **
ECHO ***************************
ECHO.
UPX.EXE --best -qq %3.dll 
GOTO PURGE


:PURGE
REM *****************************************************************
REM *** Optional - Can be Deleted to keep the C and OBJ files     ***
REM *****************************************************************
REM IF EXIST %3.c DEL %3.c
IF EXIST %3.obj DEL %3.obj
REM IF EXIST %3.frm DEL %3.bas
GOTO END1

:BCXERROR
ECHO.
ECHO *********************************************************************
ECHO ***                                                               ***
ECHO **                BCX TRANSLATION ERROR HAS OCCURED.               **
ECHO **                      C file does not exist!                     **
ECHO ***                                                               ***
ECHO *********************************************************************
GOTO END2

:PELLESCERROR
ECHO.
ECHO *********************************************************************
ECHO ***                                                               ***
ECHO **              PellesC COMPILATION ERROR HAS OCCURED.             **
ECHO **                     OBJ file does not exist!                    **
ECHO ***                                                               ***
ECHO *********************************************************************
GOTO END2

:LNKERROR
ECHO.
ECHO *********************************************************************
ECHO ***                                                               ***
ECHO **               PellesC LINK ERROR HAS OCCURED.                   **
ECHO **                   EXE was not produced!!                        **
ECHO ***                                                               ***
ECHO *********************************************************************
GOTO END2

:MKERROR
ECHO.
ECHO **************************************************************************************************
ECHO ***                                                                                            ***
ECHO ***                        BUILD ERROR HAS OCCURED!!!                                          ***
ECHO **                           NO SOURCE INPUT FILE !!                                            **
ECHO *                                                                                                *
ECHO *                         PELLESC Batch for BCX v1.15                                            *
ECHO **              Makes EXEs (CON and GUI and DLL and CCON and CGUI).                             **
ECHO *** Usage: PELLESC.BAT [CON or GUI or DLL or CCON or CGUI] [UPX or NOUPX] File1 File2 File3... ***
ECHO ***                                                                                            ***
ECHO **************************************************************************************************
GOTO END2

:END1
ECHO.
ECHO *********************************************************************
ECHO ***                                                               ***
ECHO **                 BUILD SUCCESSFULLY COMPLETED                    **
ECHO ***                                                               ***
ECHO *********************************************************************
:END2


