'control constants

CONST   EDIT_1          = 111

'menu constants

CONST   IDM_NEW         = 100
CONST   IDM_OPEN        = 110
CONST   IDM_SAVE        = 120
CONST   IDM_SAVEAS      = 130
CONST   IDM_PRINT       = 140
CONST   IDM_PAGESETUP   = 150
CONST   IDM_EXIT        = 160

'Edit Menu

CONST   IDM_UNDO        = 200
CONST   IDM_SELECTALL   = 205
CONST   IDM_CUT         = 210
CONST   IDM_COPY        = 220
CONST   IDM_PASTE       = 230

' Help Menu

CONST   IDM_HELPTOPICS  = 300
CONST   IDM_ABOUT       = 310

' Window Controls

CONST   IDACCEL         = 400
CONST   IDM_DELETE      = 410
CONST   IDM_CLOSE       = 420
CONST   IDMAINMENU      = 430
CONST   IDAPPLICON      = 440
CONST   IDAPPLCURSOR    = 450
CONST   IDS_FILEMENU    = 2000
CONST   IDS_HELPMENU    = 2010
CONST   IDS_SYSMENU     = 2030
CONST   IDM_STATUSBAR   = 3000
CONST   IDD_ABOUT  = 460
CONST   ID_TOOLBAR  = 805
CONST   IDC_EDIT        = 900

'program variables

GLOBAL  AppName$
GLOBAL  Caption$
GLOBAL  AppMenu$

GLOBAL  szFile$
GLOBAL  szFileTitle$

GLOBAL  Form1          AS  HWND
GLOBAL  Edit1          AS  HWND
GLOBAL  Wc             AS  WNDCLASS
GLOBAL  OpenFileName   AS  OPENFILENAME

DIM wRect       AS RECT   'rect structure for window pos
DIM ww          AS DWORD   'window width
DIM wh          AS DWORD   'window height
DIM bNeedSave   AS BOOL
DIM bSave       AS BOOL
DIM iReturn     AS DWORD



FUNCTION WINMAIN
  LOCAL Msg AS  MSG
  AppName$  = "Editor_Demo"
  AppMenu$  = "IDMAINMENU"
  Caption$  = "Editor by Doyle Whisenant"
  bSave = TRUE
  bNeedSave = FALSE

  If FINDFIRSTINSTANCE(AppName$) Then Exit Function

  Wc.style           = CS_HREDRAW OR CS_VREDRAW
  Wc.lpfnWndProc     = WndProc
  Wc.cbClsExtra      = 0
  Wc.cbWndExtra      = 0
  Wc.hInstance       = hInst
'  Wc.hIcon           = LoadIcon      ( NULL,IDI_APPLICATION )
  Wc.hIcon           = LoadIcon     ( hInst, MAKEINTRESOURCE(12345))
  Wc.hCursor         = LoadCursor       ( NULL,IDC_ARROW )
  Wc.hbrBackground   = GetStockObject     ( WHITE_BRUSH )
  Wc.lpszMenuName    = AppMenu$
  Wc.lpszClassName   = AppName$
  RegisterClass(&Wc)


' create the main window
  Form1 = CreateWindow(AppName$, Caption$, WS_CAPTION OR WS_MAXIMIZEBOX OR WS_MINIMIZEBOX OR _
  WS_SYSMENU OR WS_VISIBLE,0,0, 600, 500, NULL, NULL, hInst, NULL)

' create the edit window
  Edit1 = CreateWindow("edit",NULL, WS_CHILD OR WS_VISIBLE OR WS_BORDER OR _
  ES_LEFT OR WS_HSCROLL OR WS_VSCROLL OR ES_MULTILINE OR  _
  ES_AUTOVSCROLL OR ES_AUTOHSCROLL,0, 0, 550, 450, _
  Form1, EDIT_1, hInst,NULL )

  PosMainWindow  (Form1)              'set main window pos
  ShowWindow    (Form1,CmdShow)       'show that baby!
  UpdateWindow  (Form1)               'update it

  While GetMessage (&Msg,NULL,0,0)    'message loop
    TranslateMessage  (&Msg)
    DispatchMessage   (&Msg)
  Wend

  Function = Msg.wParam               'return this
End Function






FUNCTION InitOpenFileName()                'init the openfilename struct

  szFile$ = ""                               'file to open/save
  szFileTitle$ = ""                          'file name
  OpenFileName.lStructSize       = sizeof(OPENFILENAME)
  OpenFileName.hwndOwner         = Form1
  OpenFileName.hInstance         = GetModuleHandle(0)
' --------------------------------------------------------------------
  ! OpenFileName.lpstrFilter =
  ! "Basic Files (*.BAS)\0*.bas\0All Files(*.*)\0*.*\0\0";
' --------------------------------------------------------------------
  OpenFileName.lpstrCustomFilter = NULL
  OpenFileName.nMaxCustFilter    = 0
  OpenFileName.nFilterIndex      = 0
  OpenFileName.lpstrFile         = szFile$
  OpenFileName.nMaxFile          = MAX_PATH
  OpenFileName.lpstrFileTitle    = szFileTitle$
  OpenFileName.nMaxFileTitle     = MAX_PATH
  OpenFileName.lpstrInitialDir   = Curdir$
  OpenFileName.lpstrTitle        = NULL
  OpenFileName.nFileOffset       = 0
  OpenFileName.nFileExtension    = 0
  OpenFileName.lpstrDefExt       = "*.txt"
  OpenFileName.lCustData         = 0
  OpenFileName.lpfnHook          = NULL
  OpenFileName.lpTemplateName    = NULL
  Function = 0

End Function




FUNCTION PopFileOpenDlg (Form1 AS HWND, szFile$, szFileTitle$)
  OpenFileName.lpstrTitle = "Open File"    'text for caption of file dialog box
  OpenFileName.hwndOwner = Form1           'handle of main window
  OpenFileName.lpstrFile = szFile$         'file to open
  OpenFileName.lpstrFileTitle = szFileTitle$         'file name
  OpenFileName.Flags   = OFN_HIDEREADONLY | OFN_CREATEPROMPT 'flags for dialog
  Function = GetOpenFileName (&OpenFileName)
End Function




SUB OpenNewFile(hWnd AS HWND)                         'open file code
  Local t AS DWORD
  Dim FileBuf$
  Dim File$ * 65535                                    'dim buffer for file
  File$ =""                                            'init buffer
  t = EXIST ( szFile$ )                                'make sure file exists
  IF t <> 0  THEN                                    'if it exists
    Open szFile$ For Input As Fp1                      'open 'er up!
    While Not Eof(Fp1)
      Line Input Fp1, FileBuf$
      File$ = File$ & FileBuf$ & chr$(13) & chr$(10)  'add line endings
    Wend
    Close Fp1                                         'close the file
    SendMessage(Edit1,WM_SETTEXT,0,File$)             'put it in the text editor
    Free File$                                        'free memory
  ELSE
    MessageBox( Edit1, "File open failed.", NULL, MB_OK )
  END IF
End Sub




FUNCTION PopFileSaveDlg (Form1 AS HWND, szFile$, szFileTitle$)
  OpenFileName.lpstrTitle        = "Save File"
  OpenFileName.hwndOwner         = Form1
  OpenFileName.lpstrFile         = szFile$
  OpenFileName.lpstrFileTitle    = szFileTitle$
  OpenFileName.Flags             = OFN_OVERWRITEPROMPT
  Function = GetSaveFileName (&OpenFileName)
End Function







SUB SaveOpenFile(hWnd AS HWND)
  Local t AS DWORD
  Local iLength AS DWORD
  iLength = GetWindowTextLength (Edit1)
  Dim File$ * iLength + 1
  File$ = ""
  t = GetWindowText (Edit1, File$, iLength+1)
  IF Exist(szFile$) THEN
    Open szFile$ For Binary New As Fp1
    PUT$ Fp1,File$, LEN(File$)
    Close Fp1
    Free File$
  ELSE
    MessageBox( Edit1, "File Save failed.", NULL, MB_OK )
  END IF
End Sub



Function AboutDlg (hDlg AS HWND, Msg, wParam, lParam)

  Select Case Msg
    Case WM_INITDIALOG
    Center (hDlg)

    Case WM_COMMAND
    If wParam = IDOK Then EndDialog (hDlg, 0)

    Case WM_CLOSE
    EndDialog ( hDlg,0 )

  End Select
  Function = 0
End Function






CALLBACK FUNCTION WndProc
  DIM T$
  DIM hDC AS HDC
  DIM ps  AS PAINTSTRUCT
  Dim i

  SELECT CASE CBMSG

    CASE WM_COMMAND
    IF LOWORD (wParam) = EDIT_1 THEN
      IF HIWORD (wParam) = EN_CHANGE THEN
        bNeedSave = TRUE
        IF HIWORD (wParam) = EN_ERRSPACE OR HIWORD (wParam) = EN_MAXTEXT THEN
          MsgBox  "Edit control out of space.","Error!", 16
          EXIT FUNCTION
        END IF
      END IF
      EXIT FUNCTION
    END IF

    IF LOWORD(wParam) = IDM_NEW THEN
      SendMessage(Edit1,EM_SETSEL,0,MAKELONG(-1,0))
      SendMessage(Edit1,WM_CLEAR,0,0)
      szFile$ = ""
      szFileTitle$ = ""
      Caption$ = "Editor by Doyle Whisenant"
      SetWindowText (Form1, Caption$)
      bNeedSave = FALSE
      EXIT FUNCTION
    END IF

    IF LOWORD(wParam) = IDM_OPEN THEN
      IF bNeedSave THEN i = (AskAboutSave (Edit1, szFileTitle$))

      IF i = IDCANCEL THEN
        Function = 0
      END IF

      IF i = IDNO THEN
        bNeedSave = FALSE
      END IF

      IF i = IDYES THEN
        InitOpenFileName()
        PopFileSaveDlg (Form1, szFile$, szFileTitle$)
        SaveOpenFile(Edit1)
        bNeedSave = FALSE
      END IF

      IF not bNeedSave THEN
        Caption$ = "Editor by Doyle Whisenant"
        SetWindowText (Form1, Caption$)
        InitOpenFileName()
        PopFileOpenDlg (Form1, szFile$, szFileTitle$)
        OpenNewFile(Edit1)
        Caption$ = Caption$ & " - " & szFile$
        SetWindowText (Form1, Caption$)
        bNeedSave = FALSE
      END IF
    END IF

    IF LOWORD(wParam) = IDM_PRINT THEN
      MsgBox "Sorry - Not implemented yet!", "Notice", 64
    END IF

    IF LOWORD(wParam) = IDM_SAVE THEN
      Caption$ = "BCX Editor by MeKanixx Designs"
      SetWindowText (Form1, Caption$)
      SaveOpenFile(Edit1)
      Caption$ = Caption$ & " - " & szFile$
      SetWindowText (Form1, Caption$)
      bNeedSave = FALSE
      EXIT FUNCTION
    END IF

    IF LOWORD(wParam) = IDM_SAVEAS THEN
      IF bNeedSave THEN
        i = (AskAboutSave (Edit1, szFileTitle$))
        IF i = IDCANCEL THEN
          EXIT FUNCTION
        END IF

        IF i = IDNO THEN
          bSave = FALSE
        END IF

        IF i = IDYES THEN
          bSave = TRUE
        END IF

      END IF

      IF bSave THEN
        szFile$ = ""
        szFileTitle$ = ""
        InitOpenFileName()
        PopFileSaveDlg (Form1, szFile$, szFileTitle$)
        SaveOpenFile(Edit1)
        Caption$ = Caption$ & " - " & szFile$
        SetWindowText (Form1, Caption$)
        bNeedSave = FALSE
      END IF
    END IF

    IF LOWORD(wParam) = IDM_PRINT THEN
      notice("Sorry - Not implemented yet!")
    END IF

    IF LOWORD(wParam) = IDM_DELETE THEN
      SendMessage(Edit1, WM_CLEAR, 0, 0)
      Caption$ = Caption$ & " - " & szFile$
      SetWindowText (Form1, Caption$)
      bNeedSave = TRUE
    END IF

    IF LOWORD(wParam) = IDM_UNDO THEN
      IF SendMessage(Edit1, EM_CANUNDO,0,0) THEN
        SendMessage(Edit1, WM_UNDO, 0, 0)
      ELSE
        MsgBox  "Nothing to undo!","Undo Notification", 0
      END IF
    END IF

    IF LOWORD(wParam) = IDM_CUT THEN
      SendMessage (Edit1, WM_CUT, 0, 0)
    END IF

    IF LOWORD(wParam) = IDM_COPY THEN
      SendMessage (Edit1, WM_COPY, 0, 0)
    END IF

    IF LOWORD(wParam) = IDM_PASTE THEN
      SendMessage (Edit1, WM_PASTE, 0, 0)
    END IF

    IF LOWORD(wParam) = IDM_SELECTALL THEN
      SendMessage (Edit1, EM_SETSEL, 0, MAKELONG(-1,0))
    END IF

    IF LOWORD(wParam) = IDM_EXIT  THEN   ' Was the EXIT menu clicked?
      IF bNeedSave = TRUE THEN
        MsgBox "File has changed. Save?", "Confirm", 35
        IF IDYES THEN
          InitOpenFileName()
          PopFileSaveDlg (Form1, szFile$, szFileTitle$)
          SaveOpenFile(Edit1)
        END IF
      END IF
      PostQuitMessage(0)                ' Yes .. Terminate program
    END IF

    IF LOWORD(wParam) = IDM_ABOUT THEN
      MessageBeep(MB_OK)
      DialogBox(GetModuleHandle(0),MAKEINTRESOURCE(IDD_ABOUT),Form1,AboutDlg)
    END IF
    EXIT FUNCTION

    CASE WM_SETFOCUS
    SetFocus(Edit1)
    EXIT FUNCTION


    CASE WM_PAINT
    hDC = BeginPaint(hWnd,&ps)
    T$ = "Editbox is using" & Str$(GetWindowTextLength(Edit1)) & " bytes"
    TextOut(hDC,75,128,T$,len(T$))
    EndPaint(hWnd,&ps)
    EXIT FUNCTION

    CASE WM_SIZE 'set editor size
    MoveWindow(Edit1,0, 0, LOWORD(lParam), HIWORD(lParam), TRUE)
    EXIT FUNCTION

    CASE WM_KEYDOWN
    IF wParam = VK_DELETE THEN
      SendMessage(Edit1, WM_CLEAR, 0, 0)
      Caption$ = Caption$ & " - " & szFile$
      SetWindowText (Form1, Caption$)
      bNeedSave = TRUE
    END IF
    EXIT FUNCTION

    CASE WM_DESTROY
    PostQuitMessage(0)
    EXIT FUNCTION

    CASE WM_LBUTTONDOWN
    notice ("Made it!")
    EXIT FUNCTION

  END SELECT
END FUNCTION






SUB PosMainWindow (hWnd AS HWND)
  GetWindowRect (hWnd, &wRect)
  ww = GetSystemMetrics (SM_CXSCREEN)
  wh = GetSystemMetrics (SM_CYSCREEN)-GetSystemMetrics(SM_CYCAPTION)-5
  SetWindowPos (hWnd, NULL,0,0,ww,wh,SWP_SHOWWINDOW)
End Sub




Function AskAboutSave (hWnd AS HWND, szFileTitle$)
  Local afile$
  afile$ = szFileTitle$ & " has changed. Save it?"
  iReturn = MsgBox (afile$, "Confirm", 35)
  Function = iReturn
End Function




Sub notice(a$)
  MsgBox a$, "Notice", 64
End Sub
